Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.CR4
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.score.buildin.hardmediumsoft
Class HardMediumSoftScoreDefinition

    java.lang.Object
      org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<HardMediumSoftScore>
          org.optaplanner.core.impl.score.buildin.hardmediumsoft.HardMediumSoftScoreDefinition

All Implemented Interfaces:
  Serializable, ScoreDefinition<HardMediumSoftScore>

    public class HardMediumSoftScoreDefinition

extends AbstractScoreDefinition<HardMediumSoftScore>

See Also:
  Serialized Form

Constructor Summary
`HardMediumSoftScoreDefinition()`

Method Summary
`ScoreHolder` | `buildScoreHolder(boolean constraintMatchEnabled)`
`double` | `calculateTimeGradient(HardMediumSoftScore startScore, HardMediumSoftScore endScore, HardMediumSoftScore score)` See explanation in `Termination.calculateSolverTimeGradient(DefaultSolverScope)`.
`double` | `getHardScoreTimeGradientWeight()`
`double` | `getMediumScoreTimeGradientWeight()`
`HardMediumSoftScore` | `getPerfectMaximumScore()` The perfect maximum `Score` is the `Score` of which there is no better in any problem instance.
`HardMediumSoftScore` | `getPerfectMinimumScore()` The perfect minimum `Score` is the `Score` of which there is no worse in any problem instance.
`Class<HardMediumSoftScore>` | `getScoreClass()` Returns the `Class` of the actual `Score` implementation
`Score` | `parseScore(String scoreString)` Parses the `String` and returns a `Score`.
`void` | `setHardScoreTimeGradientWeight(double hardScoreTimeGradientWeight)` It's recommended to use a number which can be exactly represented as a double, such as 0.5, 0.25, 0.75, 0.125, ... but not 0.1, 0.2, ...
`void` | `setMediumScoreTimeGradientWeight(double mediumScoreTimeGradientWeight)` It's recommended to use a number which can be exactly represented as a double, such as 0.5, 0.25, 0.75, 0.125, ... but not 0.1, 0.2, ...
`void` | `setPerfectMaximumScore(HardMediumSoftScore perfectMaximumScore)`
`void` | `setPerfectMinimumScore(HardMediumSoftScore perfectMinimumScore)`

Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractScoreDefinition
`formatScore`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### HardMediumSoftScoreDefinition

    public HardMediumSoftScoreDefinition()

Method Detail

### getHardScoreTimeGradientWeight

    public double getHardScoreTimeGradientWeight()

### setHardScoreTimeGradientWeight

    public void setHardScoreTimeGradientWeight(double hardScoreTimeGradientWeight)

  It's recommended to use a number which can be exactly represented as a double, such as 0.5, 0.25, 0.75, 0.125, ... but not 0.1, 0.2, ...

  Parameters:
    `hardScoreTimeGradientWeight` - 0.0 <= hardScoreTimeGradientWeight <= 1.0

### getMediumScoreTimeGradientWeight

    public double getMediumScoreTimeGradientWeight()

### setMediumScoreTimeGradientWeight

    public void setMediumScoreTimeGradientWeight(double mediumScoreTimeGradientWeight)

  It's recommended to use a number which can be exactly represented as a double, such as 0.5, 0.25, 0.75, 0.125, ... but not 0.1, 0.2, ...

  Parameters:
    `mediumScoreTimeGradientWeight` - 0.0 <= hardScoreTimeGradientWeight <= 1.0

### getPerfectMaximumScore

    public HardMediumSoftScore getPerfectMaximumScore()

  Description copied from interface: `ScoreDefinition`
  The perfect maximum `Score` is the `Score` of which there is no better in any problem instance. This doesn't mean that the current problem instance, or any problem instance for that matter, could ever attain that `Score`. For example, most cases have a perfect maximum `Score` of zero, as most use cases only have negative constraints.

  Specified by:
    `getPerfectMaximumScore` in interface `ScoreDefinition<HardMediumSoftScore>`
  Overrides:
    `getPerfectMaximumScore` in class `AbstractScoreDefinition<HardMediumSoftScore>`
  Returns:
    null if not supported

### setPerfectMaximumScore

    public void setPerfectMaximumScore(HardMediumSoftScore perfectMaximumScore)

### getPerfectMinimumScore

    public HardMediumSoftScore getPerfectMinimumScore()

  Description copied from interface: `ScoreDefinition`
  The perfect minimum `Score` is the `Score` of which there is no worse in any problem instance. This doesn't mean that the current problem instance, or any problem instance for that matter, could ever attain such a bad `Score`. For example, most cases have a perfect minimum `Score` of negative infinity.

  Specified by:
    `getPerfectMinimumScore` in interface `ScoreDefinition<HardMediumSoftScore>`
  Overrides:
    `getPerfectMinimumScore` in class `AbstractScoreDefinition<HardMediumSoftScore>`
  Returns:
    null if not supported

### setPerfectMinimumScore

    public void setPerfectMinimumScore(HardMediumSoftScore perfectMinimumScore)

### getScoreClass

    public Class<HardMediumSoftScore> getScoreClass()

  Description copied from interface: `ScoreDefinition`
  Returns the `Class` of the actual `Score` implementation

  Returns:
    never null

### parseScore

    public Score parseScore(String scoreString)

  Description copied from interface: `ScoreDefinition`
  Parses the `String` and returns a `Score`.

  Parameters:
    `scoreString` - never null
  Returns:
    never null
  See Also:
    `ScoreDefinition.formatScore(Score)`

### calculateTimeGradient

    public double calculateTimeGradient(HardMediumSoftScore startScore,
                                        HardMediumSoftScore endScore,
                                        HardMediumSoftScore score)

  Description copied from interface: `ScoreDefinition`
  See explanation in `Termination.calculateSolverTimeGradient(DefaultSolverScope)`.

  Parameters:
    `startScore` - never null
    `endScore` - never null
    `score` - never null
  Returns:
    between 0.0 and 1.0

### buildScoreHolder

    public ScoreHolder buildScoreHolder(boolean constraintMatchEnabled)

  Parameters:
    `constraintMatchEnabled` - true if `ScoreHolder.isConstraintMatchEnabled()` should be true
  Returns:
    never null

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.CR4
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 JBoss by Red Hat. All Rights Reserved.